package se.chalmers.tdv.test;

import static org.junit.Assert.assertArrayEquals;

import org.junit.Test;

import se.chalmers.tdv.DNF;

public class DNFTest {

	// Empty array.

	@Test
	public final void testEmpty() {
		int[] empty = new int[] {};
		DNF.dnfsort(empty);
		assertArrayEquals(new int[] {}, empty);
	}

	// Single element.

	// Share testSingle() method but, importantly, have separate method
	// with @Test annotation so that when the test fails, we know which
	// input it was!

	@Test
	public final void testSingle1() {
		testSingle(1);
	}

	@Test
	public final void testSingle2() {
		testSingle(2);
	}

	@Test
	public final void testSingle3() {
		testSingle(3);
	}

	public final void testSingle(int val) {
		int[] inp = new int[] { val };
		int[] exp = new int[] { val };
		DNF.dnfsort(inp);
		assertArrayEquals(exp, inp);
	}

	// Two elements.

	// The listing of below suggest that one should be able to generate tests,
	// but this is not part of this exercise session.

	@Test
	public final void testDouble11() {
		testGeneral(new int[] { 1, 1 }, new int[] { 1, 1 });
	}

	@Test
	public final void testDouble12() {
		testGeneral(new int[] { 1, 2 }, new int[] { 1, 2 });
	}

	@Test
	public final void testDouble13() {
		testGeneral(new int[] { 1, 3 }, new int[] { 1, 3 });
	}

	@Test
	public final void testDouble21() {
		testGeneral(new int[] { 2, 1 }, new int[] { 1, 2 });
	}

	@Test
	public final void testDouble22() {
		testGeneral(new int[] { 2, 2 }, new int[] { 2, 2 });
	}

	@Test
	public final void testDouble23() {
		testGeneral(new int[] { 2, 3 }, new int[] { 2, 3 });
	}

	@Test
	public final void testDouble31() {
		testGeneral(new int[] { 3, 1 }, new int[] { 1, 3 });
	}

	@Test
	public final void testDouble32() {
		testGeneral(new int[] { 3, 2 }, new int[] { 2, 3 });
	}

	@Test
	public final void testDouble33() {
		testGeneral(new int[] { 3, 3 }, new int[] { 3, 3 });
	}

	private void testGeneral(int[] inp, int[] exp) {
		DNF.dnfsort(inp);
		assertArrayEquals(exp, inp);
	}

}
